warning('off','all')

clearvars -except Single1 Vs edge dataD filename IDsforExport marker data handles...
    allthresholds Names csvFiles k pathname Number_of_markers AnalysisMatrix...
    falsepositive currentFolder theName count IDsforExport_1 data_for_HMs data_for_subpops...
    pathe count markercell wait Imaris LTformat confirmed textImaris textLTformat flipid mirrorid aw

for ua = 1:length(data_for_HMs)
    
    %data1{:,1:4}.data = data_for_HMs{ua,1}{1,1}(:,1:4);

    for ia = 1:size(IDsforExport_1{ua,1},2)
        [za,zza,zzza{ia}] = intersect(IDsforExport_1{ua,1}(:,ia),data_for_HMs{ua,1}{1,1}(:,4));
        Xxa{ia} = data_for_HMs{ua,1}{1,1}(zzza{ia},1);
        Yya{ia} = data_for_HMs{ua,1}{1,1}(zzza{ia},2);
        Zza{ia} = data_for_HMs{ua,1}{1,1}(zzza{ia},3);
    end
    for i = 1:length(Xxa)
        IDsXYZ{i} =  [Xxa{1,i} Yya{1,i} Zza{1,i}];
    end

    newIDsXYZa = cell(1, (length(IDsXYZ)+1));
    for i = 1:(length(IDsXYZ)+1)
        if i < (length(IDsXYZ)+1)
            newIDsXYZa{i} = IDsXYZ{1,i};
        else   
            newIDsXYZa{i} = data_for_HMs{ua,1}{1,1}(:,1:3);
        end
    end
    newIDsXYZ{ua,1} = newIDsXYZa';
    clearvars newIDsXYZa IDsXYZ Xxa Yya Zza zzza data1
end

%% Scaling
h = waitbar(20/100,'Scaling in progress...');

for ps = 1:length(newIDsXYZ)
    for os = 1:length(newIDsXYZ{ps,1})
        Structure_dataandheaderX = newIDsXYZ{ps,1}{os,1}(:,1);
        Structure_dataandheaderY = newIDsXYZ{ps,1}{os,1}(:,2);
        Structure_dataandheaderZ = newIDsXYZ{ps,1}{os,1}(:,3);
        minimaX{os} = min(Structure_dataandheaderX);
        minimaY{os} = min(Structure_dataandheaderY);
        minimaZ{os} = min(Structure_dataandheaderZ);
        maximaX{os} = max(Structure_dataandheaderX);
        maximaY{os} = max(Structure_dataandheaderY);
        maximaZ{os} = max(Structure_dataandheaderZ);
    end
    minimaXi{ps} = cell2mat(minimaX);
    minimaYi{ps} = cell2mat(minimaY);
    minimaZi{ps} = cell2mat(minimaZ);
    maximaXi{ps} = cell2mat(maximaX);
    maximaYi{ps} = cell2mat(maximaY);
    maximaZi{ps} = cell2mat(maximaZ);
end

% identifying the biggest section
a = cell2mat(minimaXi);
b = cell2mat(maximaXi);
c = b-a;                    % X-diffs of all
bXdiff = max(c);            % biggest X-diff
d = bXdiff/edge;
e = ceil(d);
bXdme = e*edge;             % multiple of edge and max X-dimension of all sections

a1 = cell2mat(minimaYi);
b1 = cell2mat(maximaYi);
c1 = b1-a1;                 % Y-diffs of all
bYdiff = max(c1);           % biggest Y-diff
d1 = bYdiff/edge;
e1 = ceil(d1);
bYdme = e1*edge;             % multiple of edge and max Y-dimension of all sections

a2 = cell2mat(minimaZi);
b2 = cell2mat(maximaZi);
c2 = b2-a2;                 % Z-diffs of all
bZdiff = max(c2);           % biggest Z-diff
d2 = bZdiff/edge;
e2 = ceil(d2);
bZdme = e2*edge;             % multiple of edge and max Z-dimension of all sections

% lay foundation for a grid over the data
l1 = cell2mat(minimaXi);
l2 = cell2mat(minimaYi);
l3 = cell2mat(minimaZi);
l4 = cell2mat(maximaXi);
l5 = cell2mat(maximaYi);
l6 = cell2mat(maximaZi);
    
smallestX =  min(l1); 
smallestY = min(l2); 
smallestZ =  min(l3); 
biggestX =  max(l4); 
biggestY =  max(l5); 
biggestZ =  max(l6); 

one = smallestX;
two = biggestX;
diffX = two-one;
three = smallestY;
four = biggestY;
diffY = four-three;
five = smallestZ;
six = biggestZ;
diffZ = six-five;

aX = abs(bXdme-diffX);   %difference of current xdiff to max&multiple 
aY = abs(bYdme-diffY);   %difference of current ydiff to max&multiple 
aZ = abs(bZdme-diffZ);   %difference of current zdiff to max&multiple 

aX2 = aX/2;
aY2 = aY/2;
aZ2 = aZ/2;

onenew  = one-aX2;      %new xmin for all sections
twonew  = two+aX2;      %new xmax for all sections 
threenew = three-aY2;   %new ymin for all sections
fournew= four+aY2;      %new ymax for all sections 
fivenew = five-aZ2;   %new ymin for all sections
sixnew= six+aZ2;      %new ymax for all sections 

newIDmin = 111111;
newIDmax = 999999;

newXYZmin = [onenew threenew fivenew];  %new min points for all sec
newXYZmax = [twonew fournew sixnew];   %new max points for all sec

AnewXYZmin = [onenew threenew fivenew newIDmin];  %new min points for all sec
AnewXYZmax = [twonew fournew sixnew newIDmax];   %new max points for all sec

for p = 1:length(newIDsXYZ)
    for o = 1:length(newIDsXYZ{p,1})
        Newdata1{o,1} = [newIDsXYZ{p,1}{o,1}; newXYZmin; newXYZmax];
    end
    Newdata{p,1} = Newdata1;
    clearvars o Newdata1
end

%%
% calculating the new matrices and differences with one MAXPOINT and one
% MINPOINT that is max and min of all section to achieve uniform grid size
% and scaling to the biggest section

for ps = 1:length(Newdata)
    for os = 1:length(Newdata{ps,1})
        Structure_dataandheaderX2 = Newdata{ps,1}{os,1}(:,1);
        Structure_dataandheaderY2 = Newdata{ps,1}{os,1}(:,2);
        Structure_dataandheaderZ2 = Newdata{ps,1}{os,1}(:,3);
        aminimaX{os} = min(Structure_dataandheaderX2);
        aminimaY{os} = min(Structure_dataandheaderY2);
        aminimaZ{os} = min(Structure_dataandheaderZ2);
        amaximaX{os} = max(Structure_dataandheaderX2);
        amaximaY{os} = max(Structure_dataandheaderY2);
        amaximaZ{os} = max(Structure_dataandheaderZ2);
    end
    uminimaXi{ps} = cell2mat(aminimaX);
    uminimaYi{ps} = cell2mat(aminimaY);
    uminimaZi{ps} = cell2mat(aminimaZ);
    umaximaXi{ps} = cell2mat(amaximaX);
    umaximaYi{ps} = cell2mat(amaximaY);
    umaximaZi{ps} = cell2mat(amaximaZ);
end


minimaX2 = cell2mat(uminimaXi);
minimaY2 = cell2mat(uminimaYi);
minimaZ2 = cell2mat(uminimaZi);
maximaX2 = cell2mat(umaximaXi);
maximaY2 = cell2mat(umaximaYi);
maximaZ2 = cell2mat(umaximaZi);

minimaX1 = min(minimaX2);
minimaY1 = min(minimaY2);
minimaZ1 = min(minimaZ2);
maximaX1 = max(maximaX2);
maximaY1 = max(maximaY2);
maximaZ1 = max(maximaZ2);

l1new = minimaX1;
l2new = minimaY1;
l3new = minimaZ1;
l4new = maximaX1;
l5new = maximaY1;
l6new = maximaZ1;

one1 = l1new;
two1 = l4new;
diffX1 = two1-one1;
three1 = l2new;
four1 = l5new;
diffY1 = four1-three1;
five1 = l3new;
six1 = l6new;
diffZ1 = six1-five1;


%% Binning cells in established 3D grid
close(h)

h = waitbar(0,'Density analysis in progress...');
    
for p = 1:length(Newdata)

    for op = 1:length(Newdata{p,1})
    
        Newdat = Newdata{p,1}{op,1};
    
        % sort and bucket the x values
        X = sortrows(Newdat,1);
        Xmin = min(X(:,1));
        X1 = diffX1/edge;
        X2 = round(X1);

        for xi = 1:X2
            X3(xi) = Xmin + (xi*(edge));
        end

        for xii = 1:X2
            if xii == 1
                X4 = find(X(:,1) <= X3(xii));
            else
                X5{xii} = find(X(:,1) <= X3(xii) & X(:,1) > X3(xii-1));
            end
        end
        X6 = {X4};
        X5(1,1) = X6;

        for xj = 1:length(X5)
            Xend{xj} = X(min(X5{1,xj}):max(X5{1,xj}),1:3);
        end

        % sort and bucket the y value
        Y = sortrows(Newdat,2);
        Ymin = min(Y(:,2));
        Y1 = diffY1/edge;
        Y2 = round(Y1);

        for yi = 1:Y2
            Y3(yi) = Ymin + (yi*(edge));
        end
        for yii = 1:Y2
            if yii == 1
                Y4 = find(Y(:,2) <= Y3(yii));
            else
                Y5{yii} = find(Y(:,2) <= Y3(yii) & Y(:,2) > Y3(yii-1));
            end
        end
        Y6 = {Y4};
        Y5(1,1) = Y6;

        for yj = 1:length(Y5)
            Yend{yj} = Y(min(Y5{1,yj}):max(Y5{1,yj}),1:3);
        end

        % sort and bucket the z value
        Z = sortrows(Newdat,3);
        Zmin = min(Z(:,3));
        Z1= diffZ1/edge;
        Z2 = round(Z1);

        for hz = 1:Z2
            Z3(hz) = Zmin + (hz*(edge));
        end
        for iz = 1:Z2
            if iz == 1
                Z4= find(Z(:,3) <= Z3(iz));
            else
                Z5{iz} = find(Z(:,3) <= Z3(iz) & Z(:,3) > Z3(iz-1));
            end
        end
        Z6 = {Z4};
        Z5(1,1) = Z6;

        for jz = 1:length(Z5)
            Zend{jz} = Z(min(Z5{1,jz}):max(Z5{1,jz}),1:3);
        end

% calculates the projection of 3D data on a 2D plane; each pixel (as
% defined by "edge" now)contains the xyz values of the cells within its boarders
        COXY = cell(length(Xend),length(Yend)); % preallocate
        m = length(Yend);
        n = length(Xend);
        
        for y = 1:m
            for x = 1:n
                COXY{x,y} = intersect(Xend{1,x},Yend{1,y},'rows');
            end
        end
        clearvars x y n m

%  extracts from the projected data the values beloging to each z plane
%  with anedge length as identified above
        COXYZc = cell(1,Z2); % preallocate
        for i = 1:Z2
            COXYZc{1,i} = cell(length(Xend),length(Yend)); % preallocate
        end
        m = length(Yend);
        n = length(Xend);
        
        for z = 1:Z2
            COXYZ = COXYZc{1,z};
            for y = 1:m
                for x = 1:n
                    COXYZ{x,y}  = intersect(COXY{x,y}, Zend{1,z},'rows');
                end
            end
            COXYZp{1,z} = COXYZ;
        end
        clearvars x y n m

% Computes the number of cells in given voxel and stores them as 2D
% matrices of each z-slice (with specified edge length); also computes the
% maximum cell number in one voxel from the whole slice
        
        for z = 1:Z2
            for y11 = 1:Y2
                for x11 = 1:X2
                    fe = size(COXYZp{1,z}{x11,y11});
                    num2{x11,y11} = fe(1);
                end
            end
            nummat = cell2mat(num2);
            nump{z} = nummat;
    
            M = max(nummat);
            MaxpP{z} = max(M);
            kkk  = cell2mat(MaxpP);
            kk = max(kkk);
        end
      
        COXYZpPS1{op} = COXYZp;
        DenspPS1{op} = nump;
        MaxpS1{op} = kk;
        Newdata11{op} = Newdat; 
        Maximaperplane1{op} = MaxpP; 

        [Xs,Ys,Zs] = meshgrid(1:Y1,1:X1,1:Z1);
        Xss1{op} = Xs;
        Yss1{op} = Ys;
        Zss1{op} = Zs;

        clearvars -except Values Densities data AnalysisMatrix dataD Vs edge DenspPS1 MaxpS1 marker...
        Names COXYZpPS1 MaxpS minimaX minimaY minimaZ maximaX maximaY maximaZ bXdme...
        bYdme Single1 filename l1new l2new l3new Xss1 Yss1 Zss1 p op  flipid mirrorid...
        allthresholds Names csvFiles k pathname Number_of_markers IDsforExport_1...
        falsepositive Threshold IDsforExport filename1 diffX1 diffY1 diffZ1...
        currentFolder theName Maximaperplane1 bZdme Newdata1 IDsXYZ newIDsXYZ data1...
        data_for_HMs data_for_subpops pathe count Newdata Newdata11 COXYZpPS DenspPS...
        MaxpS Newdata1 Maximaperplane Xss Yss Zss markercell wait handles Imaris LTformat confirmed textImaris textLTformat h aw
        waitbar(op/length(Newdata{p,1})) 
    end

    COXYZpPS{p} = COXYZpPS1;
    DenspPS{p} = DenspPS1;
    MaxpS{p} = MaxpS1;
    Newdata1{p} = Newdata11; 
    Maximaperplane{p} = Maximaperplane1; 

    Xss{p} = Xss1;
    Yss{p} = Yss1;
    Zss{p} = Zss1;
    clearvars COXYZpPS1 DenspPS1 MaxpS1 Newdata11 Maximaperplane1 Xss1 Yss1 Zss1
end
%% MCD plots
close(h)

h = waitbar(0,'Density analysis done. Plotting in progress...');   
% Maximum value of one voxel in dataset is generated
fff = cell2mat(MaxpS{1,:});
Max = max(fff(1,length(MaxpS{:})-1));
Maxpp = max(fff);

%calculate from analysis volume to 1mm3
AnlVol = edge.^3;
VolFact = (1000.^3)/(edge.^3);
MaxppVF = Maxpp * VolFact;
MaxppValue = Maxpp * MaxppVF;

NewMatrix = cell(size((DenspPS{1,1}{1,1}{1,1}),1), size((DenspPS{1,1}{1,1}{1,1}),2)); % preallocate

for g = 1:length(DenspPS)
    for i = 1:length(DenspPS{1,g})
        for k = 1:size((DenspPS{1,1}{1,1}{1,1}),1)
            for l = 1:size((DenspPS{1,1}{1,1}{1,1}),2)
                for m = 1:length(DenspPS{1,g}{1,i})
                    Vec(1,m) = DenspPS{1,g}{1,i}{1,m}(k,l);
                    MaxPerPlane = max(Vec);
                    NewMatrix{k,l} = MaxPerPlane;
                end
            end
        end
        NewMatrix_for_all1{i} = NewMatrix;
        clearvars NewMatrix
        waitbar(i/length(DenspPS{1,g}))
    end
    NewMatrix_for_all{g} = NewMatrix_for_all1;
    clearvars NewMatrix_for_all1
end

close(h)

% Parentpopulation plot(s) is/are generated
ParentPop = cell2mat(NewMatrix_for_all{1,1}{1,length(DenspPS{:})});

fig = figure('Units','normalized', 'OuterPosition',[0.3 0.3 0.3 0.5]); set(fig,'visible','off')
contourf(ParentPop,Maxpp+1,'LineStyle','none')
myColorMap = jet(Maxpp+1); 
myColorMap(1, :) = [1 1 1];
colormap(myColorMap);
caxis([-0.5 Maxpp+0.5])
daspect([1,1,1])
%set(gca,'outerposition',[0.002 0 0.996 1],'units','normalized')
%set(gca, 'LooseInset', [0,0,0,0]);
set(gca,'YTick',[]);

ch = colorbar('Southoutside');
ax = gca;
axpos = ax.Position;
cpos = ch.Position;
cpos(3) = 0.25*cpos(3);
cpos(2) = 0.8*cpos(2);
ch.Position = cpos;
ax.Position = axpos;
cha1 = get(ch,'Xtick');
cha = [cha1 Maxpp];
if cha(1,end-1) == cha(1,end)
    set(ch,'Xtick',cha1)
else
    set(ch,'Xtick',cha)
end

xTicks = get(ch, 'xtick');
xTicks2 = xTicks*MaxppVF;
xticks3 = num2cell(xTicks2);
xticks4 = cell(1,length(xticks3));
xticks4{1,1} = num2str(0);
xticks4{1,end} = num2str(xticks3{1,end}, '%10.1e');
for u = 2:(length(xticks3)-1)
	xticks4{1,u} = ' ';
end
set(ch,'XTickLabel',(xticks4))

str = 'parentpopulation';
ka = 'MaxCellDensity_';
FileName1 = [ka str];
FileName = fullfile(currentFolder, theName,FileName1);

if flipid == 1 & mirrorid == 0
    set(gca,'XDir','Reverse')
elseif flipid == 0 & mirrorid == 1
    set(gca,'YDir','Reverse')
elseif flipid == 1 & mirrorid == 1
    set(gca,'XDir','Reverse')
    set(gca,'YDir','Reverse')
end

set(gcf,'PaperPositionMode','auto')
print(fig,[FileName '.tif'],'-dtiff','-r300')
close(fig) 
BaseImg = imread([FileName '.tif']);
BaseGr = rgb2gray(BaseImg);
clearvars ag ka ai str FileName BaseImg fig

hi = waitbar(0,'Plotting in progress...');   
% Subpopulation plots and overlays with pp are generated
for i = 1:length(DenspPS{1,1})-1
    NoCell = cell2mat(NewMatrix_for_all{1,1}{1,i});
	fig1 = figure('Units','normalized', 'OuterPosition',[0.3 0.3 0.3 0.5]);
    set(fig1,'visible','off')
	contourf(NoCell,Maxpp+1,'LineStyle','none')
	myColorMap = jet(Maxpp+1); 
    myColorMap(1, :) = [1 1 1];
	colormap(myColorMap);
	caxis([-0.5 Maxpp+0.5])
	daspect([1,1,1])
    %set(gca,'outerposition',[0.002 0 0.996 1],'units','normalized')
	%set(gca,'LooseInset', [0,0,0,0]);
	set(gca,'YTick',[]);
    
	ch = colorbar('Southoutside');
    ax = gca;
    axpos = ax.Position;
	cpos = ch.Position;
    cpos(3) = 0.25*cpos(3);
    cpos(2) = 0.8*cpos(2);
    ch.Position = cpos;
    ax.Position = axpos;
	cha1 = get(ch,'Xtick');
	cha = [cha1 Maxpp];
	if cha(1,end-1) == cha(1,end)
        set(ch,'Xtick',cha1)
    else
        set(ch,'Xtick',cha)
    end

    xTicks = get(ch, 'xtick');
    xTicks2 = xTicks*MaxppVF;
    xticks3 = num2cell(xTicks2);
    xticks4 = cell(1,length(xticks3));
    xticks4{1,1} = num2str(0);
    xticks4{1,end} = num2str(xticks3{1,end}, '%10.1e');
    for u = 2:(length(xticks3)-1)
        xticks4{1,u} = ' ';
    end
    set(ch,'XTickLabel',(xticks4))
    
	if flipid == 1 & mirrorid == 0
        set(gca,'XDir','Reverse')
    elseif flipid == 0 & mirrorid == 1
        set(gca,'YDir','Reverse')
    elseif flipid == 1 & mirrorid == 1
        set(gca,'XDir','Reverse')
        set(gca,'YDir','Reverse')
    end

	str = strjoin(markercell{1,1}(i,:));
    ka = 'MaxCellDensity';
    ai = [ka '_' str];

    FileName = fullfile(currentFolder, theName, ai);
    
    set(gcf,'PaperPositionMode','auto')
	print(fig1,[FileName '.tif'],'-dtiff','-r300')
	close(fig1)
	clearvars ag ka ai str fig1 
        
	subPop = imread([FileName '.tif']);
	subPop_gr = rgb2gray(subPop);
	clearvars FileName FileName
        
	fige = figure(); 
    set(fige,'visible','off')
 	imshow(subPop);
  	hold on
 	h = imshow(BaseGr);
   	hold off


  	[M, N] =  size(BaseGr);

 	[row1, col1] = find(BaseGr < 255);
 	rowcol1 = [row1, col1];
  	[row, col] = find(subPop_gr < 255);
  	rowcol = [row, col];

  	allo1 = ones(M,N);
 	for g = 1:size(row1,1)
        allo1(row1(g,1),col1(g,1)) = 0.4;
    end
 	for g = 1:size(row,1)
        allo1(row(g,1),col(g,1)) = 0;
  	end
    set(h, 'AlphaData', allo1);
    
    str = strjoin(markercell{1,1}(i,:));
    ka = 'MaxCellDensity';
    ai = [ka '_' str '_final_overlay'];
    FileName = fullfile(currentFolder, theName, ai);
	set(gcf,'PaperPositionMode','auto')
  	print(fige,[FileName '.tif'],'-dtiff','-r300')
  	close(fige)
  	clearvars ag ka ai str FileName FileName subPop subPop_gr fig1 h M N allo row col rowcol row1 col1 rowcol1 allo1 fige
	waitbar(i/length(DenspPS{1,1})-1)
end
close(hi)