% rezises axes in the main axes/coordinate system of XIT
function reziseaxes(stats,ind_a,xmin,xmax,ymin,ymax,ax)
if isnan(xmin)
    xmin = [];
end
if isnan(xmax)
    xmax = [];
end
if isnan(ymin)
    ymin = [];
end
if isnan(ymax)
    ymax = [];
end

if isempty(xmin) &  isempty(xmax)
	ax.XTickMode  = 'auto';
elseif isempty(xmin) & strcmp(xmax,' ') == 0
    ax.XLim = ([0 xmax]);
elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	ax.XLim = ([xmin max(stats(:,ind_a))]);
elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	ax.XLim = ([xmin xmax]);
end

if isempty(ymin) & isempty(ymax)
    ax.YTickMode  = 'auto';
elseif isempty(ymin) & strcmp(ymax,' ') == 0
    ax.YLim = ([0 ymax]);
elseif strcmp(ymin,' ') == 0 & isempty(ymax)
	ax.YLim = ([ymin max(stats(:,ind_a))]);
elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
	ax.YLim = ([ymin ymax]);
end
