% rezises axes in the main axes/coordinate system of XIT
function reziseaxes3D(stats,ind_a,xmin,xmax,ymin,ymax,zmin,zmax,ax)
if isnan(xmin)
    xmin = [];
end
if isnan(xmax)
    xmax = [];
end
if isnan(ymin)
    ymin = [];
end
if isnan(ymax)
    ymax = [];
end
if isnan(zmin)
    zmin = [];
end
if isnan(zmax)
    zmax = [];
end

if isempty(xmin) &  isempty(xmax)
	ax.XTickMode  = 'auto';
elseif isempty(xmin) & strcmp(xmax,' ') == 0
    ax.XLim = ([0 xmax]);
elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	ax.XLim = ([xmin max(stats(:,ind_a))]);
elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	ax.XLim = ([xmin xmax]);
end

if isempty(ymin) & isempty(ymax)
    ax.YTickMode  = 'auto';
elseif isempty(ymin) & strcmp(ymax,' ') == 0
    ax.YLim = ([0 ymax]);
elseif strcmp(ymin,' ') == 0 & isempty(ymax)
	ax.YLim = ([ymin max(stats(:,ind_a))]);
elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
	ax.YLim = ([ymin ymax]);
end

if isempty(zmin) & isempty(zmax)
    ax.ZTickMode  = 'auto';
elseif isempty(zmin) & strcmp(zmax,' ') == 0
    ax.ZLim = ([0 zmax]);
elseif strcmp(zmin,' ') == 0 & isempty(zmax)
	ax.ZLim = ([zmin max(stats(:,ind_a))]);
elseif strcmp(zmin,' ') == 0 & strcmp(zmax,' ') == 0
	ax.ZLim = ([zmin zmax]);
end
